#Libraries
import RPi.GPIO as GPIO
from time import sleep
import datetime
from openpyxl import *

wb = load_workbook('hours.xlsx')
ws=wb["Sheet1"]
wcell=ws.cell(1,1)

#Set warnings off (optional)
GPIO.setwarnings(False)
GPIO.setmode(GPIO.BCM)
#Set Button and LED pins
Button = 23
LED = 24
LED2 = 18

row = ws.max_row +1

#Setup Button and LED
GPIO.setup(Button,GPIO.IN,pull_up_down=GPIO.PUD_UP)

GPIO.setup(LED,GPIO.OUT)
GPIO.setup(LED2,GPIO.OUT)

GPIO.output(LED,GPIO.LOW)
GPIO.output(LED2,GPIO.HIGH)




def action1(Button):
    state = GPIO.input(LED)
    now = datetime.datetime.now()
    global start
    global row
    if state:
        GPIO.output(LED,GPIO.LOW)
        GPIO.output(LED2,GPIO.HIGH)

        end = datetime.datetime.now()
        total = (end - start)
        wcell1=ws.cell(row,1)
        wcell1.value = now.strftime('%Y-%m-%d')

        wcell2=ws.cell(row,2)
        wcell2.value = now.strftime('%H:%M')

        wcell3=ws.cell(row,3)
        wcell3.value = ('OFF')

        wcell4=ws.cell(row,4)
        wcell4.value = total

        wb.save('hours.xlsx')

        row += 1
        print ("Clocked OFF")


    else:
        GPIO.output(LED,GPIO.HIGH)
        GPIO.output(LED2,GPIO.LOW)

        wcell1=ws.cell(row,1)
        wcell1.value = now.strftime('%Y-%m-%d')

        wcell2=ws.cell(row,2)
        wcell2.value = now.strftime('%H:%M')

        wcell3=ws.cell(row,3)
        wcell3.value = ('ON')

        start = datetime.datetime.now()

        wb.save('hours.xlsx')
        row += 1
        print ("Clocked ON")

GPIO.add_event_detect(Button, GPIO.BOTH, callback=action1,bouncetime=800)


print("Time Recording Started") 
try:
    while True:

        xx = 0

except KeyboardInterrupt:
    GPIO.cleanup()

print ("Time Recording Stopped")
print ("Cleaned Up GPIO's")